﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace KlodsClassLibrary
{
    public class RektankelKartotek
    {
        private List<Rektangel> rektangelListe = new List<Rektangel>();

        public int AntalRektangler
        {
            get { return rektangelListe.Count; }
        }

        public Rektangel OpretRektangel(float bredde, float længde)
        {
            Rektangel nyRek = new Rektangel(bredde, længde);
            rektangelListe.Add(nyRek);
            return nyRek;
        }
        public List<Rektangel> FindAlleRektangler()
        {
            List<Rektangel> nyListe = new List<Rektangel>();
            foreach (Rektangel rek in rektangelListe)
            {
                nyListe.Add(rek);
            }
            return nyListe;
        }
        public List<Rektangel> FindAlleRektangler2()
        {
            return (new List<Rektangel>(this.rektangelListe));
        }
        public Rektangel[] FindAlleRektangler3()
        {
            return this.rektangelListe.ToArray();
        }
        public double BeregnSamletArealAfAlleRektangler()
        {
            double totalAreal = 0;
            foreach (Rektangel rek in rektangelListe)
            {
                double rekAreal;
                rekAreal = rek.BeregnAreal();
                totalAreal += rekAreal;
            }
            return totalAreal;
        }
        public List<Rektangel> FindAlleKvadrater1()
        {
            List<Rektangel> nyListe = new List<Rektangel>();
            foreach (Rektangel rek in rektangelListe)
            {
                if (rek.Bredde == rek.Længde)
                    nyListe.Add(rek);
            }
            return nyListe;
        }
        public List<Rektangel> FindAlleKvadrater2()
        {
            List<Rektangel> nyListe = new List<Rektangel>();
            foreach (Rektangel rek in rektangelListe)
            {
                if (rek.IsKvadrat())
                    nyListe.Add(rek);
            }
            return nyListe;
        }
        public List<Rektangel> FindAlleRektanglerSorteretPåAreal()
        {
            List<Rektangel> nyListe = this.FindAlleRektangler();

            int antal = nyListe.Count;
            int antalSammenligninger = antal-1;
            //for (int gange = 0; gange < antalSammenligninger; ++gange)
            while (0 < antalSammenligninger)
            {
                for (int i = 0; i < antalSammenligninger; ++i)
                {
                    Rektangel rek1 = nyListe[i];
                    Rektangel rek2 = nyListe[i + 1];
                    if (rek2.Areal < rek1.Areal)
                    {
                        nyListe[i] = rek2;
                        nyListe[i + 1] = rek1;
                    }
                }

                --antalSammenligninger;
            }

            

            return nyListe;
        }

    }
}
